Code

help: warn if specified 'man.viewer' is unsupported, instead of erroring out
[git.git] / git-clone.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
5 #
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
9 unset CDPATH
11 OPTIONS_SPEC="\
12 git-clone [options] [--] <repo> [<dir>]
13 --
14 n,no-checkout        don't create a checkout
15 bare                 create a bare repository
16 naked                create a bare repository
17 l,local              to clone from a local repository
18 no-hardlinks         don't use local hardlinks, always copy
19 s,shared             setup as a shared repository
20 template=            path to the template directory
21 q,quiet              be quiet
22 reference=           reference repository
23 o,origin=            use <name> instead of 'origin' to track upstream
24 u,upload-pack=       path to git-upload-pack on the remote
25 depth=               create a shallow clone of that depth
27 use-separate-remote  compatibility, do not use
28 no-separate-remote   compatibility, do not use"
30 die() {
31         echo >&2 "$@"
32         exit 1
33 }
35 usage() {
36         exec "$0" -h
37 }
39 eval "$(echo "$OPTIONS_SPEC" | git rev-parse --parseopt -- "$@" || echo exit $?)"
41 get_repo_base() {
42         (
43                 cd "`/bin/pwd`" &&
44                 cd "$1" || cd "$1.git" &&
45                 {
46                         cd .git
47                         pwd
48                 }
49         ) 2>/dev/null
50 }
52 if [ -n "$GIT_SSL_NO_VERIFY" -o \
53         "`git config --bool http.sslVerify`" = false ]; then
54     curl_extra_args="-k"
55 fi
57 http_fetch () {
58         # $1 = Remote, $2 = Local
59         curl -nsfL $curl_extra_args "$1" >"$2"
60         curl_exit_status=$?
61         case $curl_exit_status in
62         126|127) exit ;;
63         *)       return $curl_exit_status ;;
64         esac
65 }
67 clone_dumb_http () {
68         # $1 - remote, $2 - local
69         cd "$2" &&
70         clone_tmp="$GIT_DIR/clone-tmp" &&
71         mkdir -p "$clone_tmp" || exit 1
72         if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
73                 "`git config --bool http.noEPSV`" = true ]; then
74                 curl_extra_args="${curl_extra_args} --disable-epsv"
75         fi
76         http_fetch "$1/info/refs" "$clone_tmp/refs" ||
77                 die "Cannot get remote repository information.
78 Perhaps git-update-server-info needs to be run there?"
79         test "z$quiet" = z && v=-v || v=
80         while read sha1 refname
81         do
82                 name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
83                 case "$name" in
84                 *^*)    continue;;
85                 esac
86                 case "$bare,$name" in
87                 yes,* | ,heads/* | ,tags/*) ;;
88                 *)      continue ;;
89                 esac
90                 if test -n "$use_separate_remote" &&
91                    branch_name=`expr "z$name" : 'zheads/\(.*\)'`
92                 then
93                         tname="remotes/$origin/$branch_name"
94                 else
95                         tname=$name
96                 fi
97                 git-http-fetch $v -a -w "$tname" "$sha1" "$1" || exit 1
98         done <"$clone_tmp/refs"
99         rm -fr "$clone_tmp"
100         http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
101         rm -f "$GIT_DIR/REMOTE_HEAD"
102         if test -f "$GIT_DIR/REMOTE_HEAD"; then
103                 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
104                 case "$head_sha1" in
105                 'ref: refs/'*)
106                         ;;
107                 *)
108                         git-http-fetch $v -a "$head_sha1" "$1" ||
109                         rm -f "$GIT_DIR/REMOTE_HEAD"
110                         ;;
111                 esac
112         fi
115 quiet=
116 local=no
117 use_local_hardlink=yes
118 local_shared=no
119 unset template
120 no_checkout=
121 upload_pack=
122 bare=
123 reference=
124 origin=
125 origin_override=
126 use_separate_remote=t
127 depth=
128 no_progress=
129 local_explicitly_asked_for=
130 test -t 1 || no_progress=--no-progress
132 while test $# != 0
133 do
134         case "$1" in
135         -n|--no-checkout)
136                 no_checkout=yes ;;
137         --naked|--bare)
138                 bare=yes ;;
139         -l|--local)
140                 local_explicitly_asked_for=yes
141                 use_local_hardlink=yes
142                 ;;
143         --no-hardlinks)
144                 use_local_hardlink=no ;;
145         -s|--shared)
146                 local_shared=yes ;;
147         --template)
148                 shift; template="--template=$1" ;;
149         -q|--quiet)
150                 quiet=-q ;;
151         --use-separate-remote|--no-separate-remote)
152                 die "clones are always made with separate-remote layout" ;;
153         --reference)
154                 shift; reference="$1" ;;
155         -o|--origin)
156                 shift;
157                 case "$1" in
158                 '')
159                     usage ;;
160                 */*)
161                     die "'$1' is not suitable for an origin name"
162                 esac
163                 git check-ref-format "heads/$1" ||
164                     die "'$1' is not suitable for a branch name"
165                 test -z "$origin_override" ||
166                     die "Do not give more than one --origin options."
167                 origin_override=yes
168                 origin="$1"
169                 ;;
170         -u|--upload-pack)
171                 shift
172                 upload_pack="--upload-pack=$1" ;;
173         --depth)
174                 shift
175                 depth="--depth=$1" ;;
176         --)
177                 shift
178                 break ;;
179         *)
180                 usage ;;
181         esac
182         shift
183 done
185 repo="$1"
186 test -n "$repo" ||
187     die 'you must specify a repository to clone.'
189 # --bare implies --no-checkout and --no-separate-remote
190 if test yes = "$bare"
191 then
192         if test yes = "$origin_override"
193         then
194                 die '--bare and --origin $origin options are incompatible.'
195         fi
196         no_checkout=yes
197         use_separate_remote=
198 fi
200 if test -z "$origin"
201 then
202         origin=origin
203 fi
205 # Turn the source into an absolute path if
206 # it is local
207 if base=$(get_repo_base "$repo"); then
208         repo="$base"
209         if test -z "$depth"
210         then
211                 local=yes
212         fi
213 elif test -f "$repo"
214 then
215         case "$repo" in /*) ;; *) repo="$PWD/$repo" ;; esac
216 fi
218 # Decide the directory name of the new repository
219 if test -n "$2"
220 then
221         dir="$2"
222 else
223         # Derive one from the repository name
224         # Try using "humanish" part of source repo if user didn't specify one
225         if test -f "$repo"
226         then
227                 # Cloning from a bundle
228                 dir=$(echo "$repo" | sed -e 's|/*\.bundle$||' -e 's|.*/||g')
229         else
230                 dir=$(echo "$repo" |
231                         sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
232         fi
233 fi
235 [ -e "$dir" ] && die "destination directory '$dir' already exists."
236 [ yes = "$bare" ] && unset GIT_WORK_TREE
237 [ -n "$GIT_WORK_TREE" ] && [ -e "$GIT_WORK_TREE" ] &&
238 die "working tree '$GIT_WORK_TREE' already exists."
239 D=
240 W=
241 cleanup() {
242         err=$?
243         test -z "$D" && rm -rf "$dir"
244         test -z "$W" && test -n "$GIT_WORK_TREE" && rm -rf "$GIT_WORK_TREE"
245         cd ..
246         test -n "$D" && rm -rf "$D"
247         test -n "$W" && rm -rf "$W"
248         exit $err
250 trap cleanup 0
251 mkdir -p "$dir" && D=$(cd "$dir" && pwd) || usage
252 test -n "$GIT_WORK_TREE" && mkdir -p "$GIT_WORK_TREE" &&
253 W=$(cd "$GIT_WORK_TREE" && pwd) && GIT_WORK_TREE="$W" && export GIT_WORK_TREE
254 if test yes = "$bare" || test -n "$GIT_WORK_TREE"; then
255         GIT_DIR="$D"
256 else
257         GIT_DIR="$D/.git"
258 fi &&
259 export GIT_DIR &&
260 GIT_CONFIG="$GIT_DIR/config" git-init $quiet ${template+"$template"} || usage
262 if test -n "$bare"
263 then
264         GIT_CONFIG="$GIT_DIR/config" git config core.bare true
265 fi
267 if test -n "$reference"
268 then
269         ref_git=
270         if test -d "$reference"
271         then
272                 if test -d "$reference/.git/objects"
273                 then
274                         ref_git="$reference/.git"
275                 elif test -d "$reference/objects"
276                 then
277                         ref_git="$reference"
278                 fi
279         fi
280         if test -n "$ref_git"
281         then
282                 ref_git=$(cd "$ref_git" && pwd)
283                 echo "$ref_git/objects" >"$GIT_DIR/objects/info/alternates"
284                 (
285                         GIT_DIR="$ref_git" git for-each-ref \
286                                 --format='%(objectname) %(*objectname)'
287                 ) |
288                 while read a b
289                 do
290                         test -z "$a" ||
291                         git update-ref "refs/reference-tmp/$a" "$a"
292                         test -z "$b" ||
293                         git update-ref "refs/reference-tmp/$b" "$b"
294                 done
295         else
296                 die "reference repository '$reference' is not a local directory."
297         fi
298 fi
300 rm -f "$GIT_DIR/CLONE_HEAD"
302 # We do local magic only when the user tells us to.
303 case "$local" in
304 yes)
305         ( cd "$repo/objects" ) ||
306                 die "cannot chdir to local '$repo/objects'."
308         if test "$local_shared" = yes
309         then
310                 mkdir -p "$GIT_DIR/objects/info"
311                 echo "$repo/objects" >>"$GIT_DIR/objects/info/alternates"
312         else
313                 l= &&
314                 if test "$use_local_hardlink" = yes
315                 then
316                         # See if we can hardlink and drop "l" if not.
317                         sample_file=$(cd "$repo" && \
318                                       find objects -type f -print | sed -e 1q)
319                         # objects directory should not be empty because
320                         # we are cloning!
321                         test -f "$repo/$sample_file" ||
322                                 die "fatal: cannot clone empty repository"
323                         if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
324                         then
325                                 rm -f "$GIT_DIR/objects/sample"
326                                 l=l
327                         elif test -n "$local_explicitly_asked_for"
328                         then
329                                 echo >&2 "Warning: -l asked but cannot hardlink to $repo"
330                         fi
331                 fi &&
332                 cd "$repo" &&
333                 find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
334         fi
335         git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
336         ;;
337 *)
338         case "$repo" in
339         rsync://*)
340                 case "$depth" in
341                 "") ;;
342                 *) die "shallow over rsync not supported" ;;
343                 esac
344                 rsync $quiet -av --ignore-existing  \
345                         --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
346                 exit
347                 # Look at objects/info/alternates for rsync -- http will
348                 # support it natively and git native ones will do it on the
349                 # remote end.  Not having that file is not a crime.
350                 rsync -q "$repo/objects/info/alternates" \
351                         "$GIT_DIR/TMP_ALT" 2>/dev/null ||
352                         rm -f "$GIT_DIR/TMP_ALT"
353                 if test -f "$GIT_DIR/TMP_ALT"
354                 then
355                     ( cd "$D" &&
356                       . git-parse-remote &&
357                       resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
358                     while read alt
359                     do
360                         case "$alt" in 'bad alternate: '*) die "$alt";; esac
361                         case "$quiet" in
362                         '')     echo >&2 "Getting alternate: $alt" ;;
363                         esac
364                         rsync $quiet -av --ignore-existing  \
365                             --exclude info "$alt" "$GIT_DIR/objects" || exit
366                     done
367                     rm -f "$GIT_DIR/TMP_ALT"
368                 fi
369                 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
370                 ;;
371         https://*|http://*|ftp://*)
372                 case "$depth" in
373                 "") ;;
374                 *) die "shallow over http or ftp not supported" ;;
375                 esac
376                 if test -z "@@NO_CURL@@"
377                 then
378                         clone_dumb_http "$repo" "$D"
379                 else
380                         die "http transport not supported, rebuild Git with curl support"
381                 fi
382                 ;;
383         *)
384                 if [ -f "$repo" ] ; then
385                         git bundle unbundle "$repo" > "$GIT_DIR/CLONE_HEAD" ||
386                         die "unbundle from '$repo' failed."
387                 else
388                         case "$upload_pack" in
389                         '') git-fetch-pack --all -k $quiet $depth $no_progress "$repo";;
390                         *) git-fetch-pack --all -k \
391                                 $quiet "$upload_pack" $depth $no_progress "$repo" ;;
392                         esac >"$GIT_DIR/CLONE_HEAD" ||
393                         die "fetch-pack from '$repo' failed."
394                 fi
395                 ;;
396         esac
397         ;;
398 esac
399 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
401 if test -f "$GIT_DIR/CLONE_HEAD"
402 then
403         # Read git-fetch-pack -k output and store the remote branches.
404         if [ -n "$use_separate_remote" ]
405         then
406                 branch_top="remotes/$origin"
407         else
408                 branch_top="heads"
409         fi
410         tag_top="tags"
411         while read sha1 name
412         do
413                 case "$name" in
414                 *'^{}')
415                         continue ;;
416                 HEAD)
417                         destname="REMOTE_HEAD" ;;
418                 refs/heads/*)
419                         destname="refs/$branch_top/${name#refs/heads/}" ;;
420                 refs/tags/*)
421                         destname="refs/$tag_top/${name#refs/tags/}" ;;
422                 *)
423                         continue ;;
424                 esac
425                 git update-ref -m "clone: from $repo" "$destname" "$sha1" ""
426         done < "$GIT_DIR/CLONE_HEAD"
427 fi
429 if test -n "$W"; then
430         cd "$W" || exit
431 else
432         cd "$D" || exit
433 fi
435 if test -z "$bare"
436 then
437         # a non-bare repository is always in separate-remote layout
438         remote_top="refs/remotes/$origin"
439         head_sha1=
440         test ! -r "$GIT_DIR/REMOTE_HEAD" || head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
441         case "$head_sha1" in
442         'ref: refs/'*)
443                 # Uh-oh, the remote told us (http transport done against
444                 # new style repository with a symref HEAD).
445                 # Ideally we should skip the guesswork but for now
446                 # opt for minimum change.
447                 head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
448                 head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
449                 ;;
450         esac
452         # The name under $remote_top the remote HEAD seems to point at.
453         head_points_at=$(
454                 (
455                         test -f "$GIT_DIR/$remote_top/master" && echo "master"
456                         cd "$GIT_DIR/$remote_top" &&
457                         find . -type f -print | sed -e 's/^\.\///'
458                 ) | (
459                 done=f
460                 while read name
461                 do
462                         test t = $done && continue
463                         branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
464                         if test "$head_sha1" = "$branch_tip"
465                         then
466                                 echo "$name"
467                                 done=t
468                         fi
469                 done
470                 )
471         )
473         # Upstream URL
474         git config remote."$origin".url "$repo" &&
476         # Set up the mappings to track the remote branches.
477         git config remote."$origin".fetch \
478                 "+refs/heads/*:$remote_top/*" '^$' &&
480         # Write out remote.$origin config, and update our "$head_points_at".
481         case "$head_points_at" in
482         ?*)
483                 # Local default branch
484                 git symbolic-ref HEAD "refs/heads/$head_points_at" &&
486                 # Tracking branch for the primary branch at the remote.
487                 git update-ref HEAD "$head_sha1" &&
489                 rm -f "refs/remotes/$origin/HEAD"
490                 git symbolic-ref "refs/remotes/$origin/HEAD" \
491                         "refs/remotes/$origin/$head_points_at" &&
493                 git config branch."$head_points_at".remote "$origin" &&
494                 git config branch."$head_points_at".merge "refs/heads/$head_points_at"
495                 ;;
496         '')
497                 if test -z "$head_sha1"
498                 then
499                         # Source had nonexistent ref in HEAD
500                         echo >&2 "Warning: Remote HEAD refers to nonexistent ref, unable to checkout."
501                         no_checkout=t
502                 else
503                         # Source had detached HEAD pointing nowhere
504                         git update-ref --no-deref HEAD "$head_sha1" &&
505                         rm -f "refs/remotes/$origin/HEAD"
506                 fi
507                 ;;
508         esac
510         case "$no_checkout" in
511         '')
512                 test "z$quiet" = z -a "z$no_progress" = z && v=-v || v=
513                 git read-tree -m -u $v HEAD HEAD
514         esac
515 fi
516 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"
518 trap - 0